# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = ['AccountOnboardingArgs', 'AccountOnboarding']

@pulumi.input_type
class AccountOnboardingArgs:
    def __init__(__self__, *,
                 account_id: pulumi.Input[str],
                 onboarding_status: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a AccountOnboarding resource.
        :param pulumi.Input[str] account_id: The account IDs
        :param pulumi.Input[str] onboarding_status: Onboarding status of the account
        """
        pulumi.set(__self__, "account_id", account_id)
        if onboarding_status is not None:
            pulumi.set(__self__, "onboarding_status", onboarding_status)

    @property
    @pulumi.getter(name="accountId")
    def account_id(self) -> pulumi.Input[str]:
        """
        The account IDs
        """
        return pulumi.get(self, "account_id")

    @account_id.setter
    def account_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "account_id", value)

    @property
    @pulumi.getter(name="onboardingStatus")
    def onboarding_status(self) -> Optional[pulumi.Input[str]]:
        """
        Onboarding status of the account
        """
        return pulumi.get(self, "onboarding_status")

    @onboarding_status.setter
    def onboarding_status(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "onboarding_status", value)


@pulumi.input_type
class _AccountOnboardingState:
    def __init__(__self__, *,
                 account_id: Optional[pulumi.Input[str]] = None,
                 onboarding_status: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering AccountOnboarding resources.
        :param pulumi.Input[str] account_id: The account IDs
        :param pulumi.Input[str] onboarding_status: Onboarding status of the account
        """
        if account_id is not None:
            pulumi.set(__self__, "account_id", account_id)
        if onboarding_status is not None:
            pulumi.set(__self__, "onboarding_status", onboarding_status)

    @property
    @pulumi.getter(name="accountId")
    def account_id(self) -> Optional[pulumi.Input[str]]:
        """
        The account IDs
        """
        return pulumi.get(self, "account_id")

    @account_id.setter
    def account_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "account_id", value)

    @property
    @pulumi.getter(name="onboardingStatus")
    def onboarding_status(self) -> Optional[pulumi.Input[str]]:
        """
        Onboarding status of the account
        """
        return pulumi.get(self, "onboarding_status")

    @onboarding_status.setter
    def onboarding_status(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "onboarding_status", value)


class AccountOnboarding(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 account_id: Optional[pulumi.Input[str]] = None,
                 onboarding_status: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Resource for Account Onboarding.

        ## Admin Permission Type

        * `Rulestack` (for `scope="Local"`)
        * `Global Rulestack` (for `scope="Global"`)

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] account_id: The account IDs
        :param pulumi.Input[str] onboarding_status: Onboarding status of the account
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: AccountOnboardingArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Resource for Account Onboarding.

        ## Admin Permission Type

        * `Rulestack` (for `scope="Local"`)
        * `Global Rulestack` (for `scope="Global"`)

        :param str resource_name: The name of the resource.
        :param AccountOnboardingArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(AccountOnboardingArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 account_id: Optional[pulumi.Input[str]] = None,
                 onboarding_status: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = AccountOnboardingArgs.__new__(AccountOnboardingArgs)

            if account_id is None and not opts.urn:
                raise TypeError("Missing required property 'account_id'")
            __props__.__dict__["account_id"] = account_id
            __props__.__dict__["onboarding_status"] = onboarding_status
        super(AccountOnboarding, __self__).__init__(
            'cloudngfwaws:index/accountOnboarding:AccountOnboarding',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            account_id: Optional[pulumi.Input[str]] = None,
            onboarding_status: Optional[pulumi.Input[str]] = None) -> 'AccountOnboarding':
        """
        Get an existing AccountOnboarding resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] account_id: The account IDs
        :param pulumi.Input[str] onboarding_status: Onboarding status of the account
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _AccountOnboardingState.__new__(_AccountOnboardingState)

        __props__.__dict__["account_id"] = account_id
        __props__.__dict__["onboarding_status"] = onboarding_status
        return AccountOnboarding(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="accountId")
    def account_id(self) -> pulumi.Output[str]:
        """
        The account IDs
        """
        return pulumi.get(self, "account_id")

    @property
    @pulumi.getter(name="onboardingStatus")
    def onboarding_status(self) -> pulumi.Output[str]:
        """
        Onboarding status of the account
        """
        return pulumi.get(self, "onboarding_status")

